### Hierarchy

- Dropdown

### Implements

- OnInit
- AfterContentInit
- AfterViewInit
- OnDestroy
- ControlValueAccessor

## Index

### Inputs

- appendInline
- clearText
- disableArrowKeys
- disabled
- displayValue
- dropUp
- helperText
- id
- inline
- invalid
- invalidText
- itemValueKey
- label
- menuButtonLabel
- placeholder
- scrollableContainer
- selectedLabel
- selectionFeedback
- size
- skeleton
- theme
- type
- warn
- warnText
- value

### Outputs

- close
- onClose
- selected

### Constructors

- constructor

### Properties

- _dropUp
- _writtenValue
- appRef
- appendInline
- clearText
- close
- disableArrowKeys
- disabled
- displayValue
- dropUp
- dropdownButton
- dropdownMenu
- dropdownService
- elementRef
- elementService
- helperText
- hostClass
- i18n
- id
- inline
- invalid
- invalidText
- itemValueKey
- keyboardNav
- label
- menuButtonLabel
- menuIsClosed
- noop
- onClose
- onTouchedCallback
- outsideClick
- outsideKey
- placeholder
- scrollableContainer
- selected
- selectedLabel
- selectionFeedback
- size
- skeleton
- theme
- type
- view
- visibilitySubscription
- warn
- warnText
- dropdownCount

### Accessors

- value
- writtenValue

### Methods

- _appendToBody
- _appendToDropdown
- _keyboardNav
- _noop
- _outsideClick
- _outsideKey
- _shouldDropUp
- checkForReorder
- clearSelected
- closeMenu
- closedDropdownNavigation
- getDisplayStringValue
- getRenderTemplateContext
- getSelectedCount
- isRenderString
- isTemplate
- ngAfterContentInit
- ngAfterViewInit
- ngOnDestroy
- ngOnInit
- onBlur
- onKeyDown
- openMenu
- propagateChange
- registerOnChange
- registerOnTouched
- setDisabledState
- toggleMenu
- valueSelected
- writeValue

## Constructors

### constructor

- new Dropdown(elementRef: ElementRef, i18n: I18n, dropdownService: DropdownService, appRef: ApplicationRef, elementService: ElementService): Dropdown

- - Defined in src/dropdown/dropdown.component.ts:351

  #### Parameters

  - ##### elementRef: ElementRef

  - ##### i18n: I18n

  - ##### dropdownService: DropdownService

  - ##### appRef: ApplicationRef

  - ##### elementService: ElementService

  #### Returns Dropdown

## Properties

### _dropUp

_dropUp: boolean = false

- Defined in src/dropdown/dropdown.component.ts:328

### Private _writtenValue

_writtenValue: any = []

- Defined in src/dropdown/dropdown.component.ts:342

### Protected appRef

appRef: ApplicationRef

- Defined in src/dropdown/dropdown.component.ts:360

### appendInline

@Input()
appendInline: boolean = null

- Defined in src/dropdown/dropdown.component.ts:246

### clearText

@Input()
clearText: string = this.i18n.get().DROPDOWN.CLEAR

- Defined in src/dropdown/dropdown.component.ts:195

### close

@Output()
close: EventEmitter<any> = new EventEmitter<any>()

- Defined in src/dropdown/dropdown.component.ts:301

### disableArrowKeys

@Input()
disableArrowKeys: boolean = false

- Defined in src/dropdown/dropdown.component.ts:226

### disabled

@Input()
disabled: boolean = false

- Defined in src/dropdown/dropdown.component.ts:214

### displayValue

@Input()
displayValue: string | TemplateRef<any> = ""

- Defined in src/dropdown/dropdown.component.ts:191

### dropUp

@Input()
dropUp: boolean

- Defined in src/dropdown/dropdown.component.ts:289

### dropdownButton

@ViewChild({"selector":"dropdownButton","opts":"{ static: true }"})
dropdownButton: any

- Defined in src/dropdown/dropdown.component.ts:312

### dropdownMenu

@ViewChild({"selector":"dropdownMenu","opts":"{ static: true }"})
dropdownMenu: any

- Defined in src/dropdown/dropdown.component.ts:317

### Protected dropdownService

dropdownService: DropdownService

- Defined in src/dropdown/dropdown.component.ts:359

### Protected elementRef

elementRef: ElementRef

- Defined in src/dropdown/dropdown.component.ts:357

### Protected elementService

elementService: ElementService

- Defined in src/dropdown/dropdown.component.ts:361

### helperText

@Input()
helperText: string | TemplateRef<any>

- Defined in src/dropdown/dropdown.component.ts:183

### hostClass

@HostBinding({"hostPropertyName":"class.bx--dropdown__wrapper"})
hostClass: boolean = true

- Defined in src/dropdown/dropdown.component.ts:319

### Protected i18n

i18n: I18n

- Defined in src/dropdown/dropdown.component.ts:358

### id

@Input()
id: string = `dropdown-${Dropdown.dropdownCount++}`

- Defined in src/dropdown/dropdown.component.ts:175

### inline

@Input()
inline: boolean = false

- Defined in src/dropdown/dropdown.component.ts:222

### invalid

@Input()
invalid: boolean = false

- Defined in src/dropdown/dropdown.component.ts:230

### invalidText

@Input()
invalidText: string | TemplateRef<any>

- Defined in src/dropdown/dropdown.component.ts:234

### itemValueKey

@Input()
itemValueKey: string

- Defined in src/dropdown/dropdown.component.ts:268

### keyboardNav

keyboardNav: any = this._keyboardNav.bind(this)

- Defined in src/dropdown/dropdown.component.ts:335

### label

@Input()
label: string | TemplateRef<any>

- Defined in src/dropdown/dropdown.component.ts:179

### menuButtonLabel

@Input()
menuButtonLabel: any = this.i18n.get().DROPDOWN.OPEN

- Defined in src/dropdown/dropdown.component.ts:280

### menuIsClosed

menuIsClosed: boolean = true

- Defined in src/dropdown/dropdown.component.ts:323

### noop

noop: any = this._noop.bind(this)

- Defined in src/dropdown/dropdown.component.ts:332

### onClose

@Output()
onClose: EventEmitter<any> = new EventEmitter<any>()

- Defined in src/dropdown/dropdown.component.ts:297

### Protected onTouchedCallback

onTouchedCallback: function = this._noop

- Defined in src/dropdown/dropdown.component.ts:339

#### Type declaration

- - (): void

  - #### Returns void

### outsideClick

outsideClick: any = this._outsideClick.bind(this)

- Defined in src/dropdown/dropdown.component.ts:333

### outsideKey

outsideKey: any = this._outsideKey.bind(this)

- Defined in src/dropdown/dropdown.component.ts:334

### placeholder

@Input()
placeholder: string = ""

- Defined in src/dropdown/dropdown.component.ts:187

### scrollableContainer

@Input()
scrollableContainer: string

- Defined in src/dropdown/dropdown.component.ts:251

### selected

@Output()
selected: EventEmitter<Object> = new EventEmitter<Object>()

- Defined in src/dropdown/dropdown.component.ts:293

### selectedLabel

@Input()
selectedLabel: any = this.i18n.get().DROPDOWN.SELECTED

- Defined in src/dropdown/dropdown.component.ts:285

### selectionFeedback

@Input()
selectionFeedback: "top" | "fixed" | "top-after-reopen" = "top-after-reopen"

- Defined in src/dropdown/dropdown.component.ts:275

### size

@Input()
size: "sm" | "md" | "xl" = "md"

- Defined in src/dropdown/dropdown.component.ts:201

### skeleton

@Input()
skeleton: boolean = false

- Defined in src/dropdown/dropdown.component.ts:218

### theme

@Input()
theme: "light" | "dark" = "dark"

- Defined in src/dropdown/dropdown.component.ts:210

### type

@Input()
type: "single" | "multi" = "single"

- Defined in src/dropdown/dropdown.component.ts:206

### view

@ContentChild({"selector":"AbstractDropdownView","opts":"{ static: true }"})
view: AbstractDropdownView

- Defined in src/dropdown/dropdown.component.ts:307

### Protected visibilitySubscription

visibilitySubscription: Subscription = new Subscription()

- Defined in src/dropdown/dropdown.component.ts:337

### warn

@Input()
warn: boolean = false

- Defined in src/dropdown/dropdown.component.ts:238

### warnText

@Input()
warnText: string | TemplateRef<any>

- Defined in src/dropdown/dropdown.component.ts:242

### Static dropdownCount

dropdownCount: number = 0

- Defined in src/dropdown/dropdown.component.ts:174

## Accessors

### value

@Input()
value:

- Defined in src/dropdown/dropdown.component.ts:257
- Defined in src/dropdown/dropdown.component.ts:262

### Protected writtenValue

writtenValue:

- Defined in src/dropdown/dropdown.component.ts:343
- Defined in src/dropdown/dropdown.component.ts:346

## Methods

### _appendToBody

- _appendToBody(): void

- - Defined in src/dropdown/dropdown.component.ts:685

  #### Returns void

### _appendToDropdown

- _appendToDropdown(): void

- - Defined in src/dropdown/dropdown.component.ts:677

  #### Returns void

### _keyboardNav

- _keyboardNav(event: KeyboardEvent): void

- - Defined in src/dropdown/dropdown.component.ts:656

  #### Parameters

  - ##### event: KeyboardEvent

  #### Returns void

### _noop

- _noop(): void

- - Defined in src/dropdown/dropdown.component.ts:636

  #### Returns void

### _outsideClick

- _outsideClick(event: any): void

- - Defined in src/dropdown/dropdown.component.ts:640

  #### Parameters

  - ##### event: any

  #### Returns void

### _outsideKey

- _outsideKey(event: any): void

- - Defined in src/dropdown/dropdown.component.ts:648

  #### Parameters

  - ##### event: any

  #### Returns void

### _shouldDropUp

- _shouldDropUp(): boolean

- - Defined in src/dropdown/dropdown.component.ts:699

  #### Returns boolean

### Protected checkForReorder

- checkForReorder(): void

- - Defined in src/dropdown/dropdown.component.ts:809

  #### Returns void

### clearSelected

- clearSelected(): void

- - Defined in src/dropdown/dropdown.component.ts:617

  #### Returns void

### closeMenu

- closeMenu(): void

- - Defined in src/dropdown/dropdown.component.ts:764

  #### Returns void

### closedDropdownNavigation

- closedDropdownNavigation(event: any): void

- - Defined in src/dropdown/dropdown.component.ts:556

  #### Parameters

  - ##### event: any

  #### Returns void

### getDisplayStringValue

- getDisplayStringValue(): Observable<string>

- - Defined in src/dropdown/dropdown.component.ts:576

  #### Returns Observable<string>

### getRenderTemplateContext

- getRenderTemplateContext(): object | object | object

- - Defined in src/dropdown/dropdown.component.ts:597

  #### Returns object | object | object

### getSelectedCount

- getSelectedCount(): number

- - Defined in src/dropdown/dropdown.component.ts:611

  #### Returns number

### isRenderString

- isRenderString(): boolean

- - Defined in src/dropdown/dropdown.component.ts:593

  #### Returns boolean

### isTemplate

- isTemplate(value: any): boolean

- - Defined in src/dropdown/dropdown.component.ts:802

  #### Parameters

  - ##### value: any

  #### Returns boolean

### ngAfterContentInit

- ngAfterContentInit(): void

- - Defined in src/dropdown/dropdown.component.ts:376

  #### Returns void

### ngAfterViewInit

- ngAfterViewInit(): void

- - Defined in src/dropdown/dropdown.component.ts:423

  #### Returns void

### ngOnDestroy

- ngOnDestroy(): void

- - Defined in src/dropdown/dropdown.component.ts:440

  #### Returns void

### ngOnInit

- ngOnInit(): void

- - Defined in src/dropdown/dropdown.component.ts:367

  #### Returns void

### onBlur

- onBlur(): void

- - Defined in src/dropdown/dropdown.component.ts:488

  #### Returns void

### onKeyDown

@HostListener({"eventName":"keydown","args":"[$event]"})

- onKeyDown(event: KeyboardEvent): void

- - Defined in src/dropdown/dropdown.component.ts:524

  #### Parameters

  - ##### event: KeyboardEvent

  #### Returns void

### openMenu

- openMenu(): void

- - Defined in src/dropdown/dropdown.component.ts:719

  #### Returns void

### propagateChange

- propagateChange(_: any): void

- - Defined in src/dropdown/dropdown.component.ts:506

  #### Parameters

  - ##### _: any

  #### Returns void

### registerOnChange

- registerOnChange(fn: any): void

- - Defined in src/dropdown/dropdown.component.ts:492

  #### Parameters

  - ##### fn: any

  #### Returns void

### registerOnTouched

- registerOnTouched(fn: any): void

- - Defined in src/dropdown/dropdown.component.ts:499

  #### Parameters

  - ##### fn: any

  #### Returns void

### setDisabledState

- setDisabledState(isDisabled: boolean): void

- - Defined in src/dropdown/dropdown.component.ts:515

  #### Parameters

  - ##### isDisabled: boolean

  #### Returns void

### toggleMenu

- toggleMenu(): void

- - Defined in src/dropdown/dropdown.component.ts:794

  #### Returns void

### valueSelected

- valueSelected(): boolean

- - Defined in src/dropdown/dropdown.component.ts:631

  #### Returns boolean

### writeValue

- writeValue(value: any): void

- - Defined in src/dropdown/dropdown.component.ts:449

  #### Parameters

  - ##### value: any

  #### Returns void

Generated using TypeDoc